# Welcome to Context Aware Jenkins Job Transfers

**Context Aware Jenkins Job Transfers** provides a pythonic way of transferring jobs between two Jenkins Servers present within a network. It is essentially a Python wrapper for the Jenkins REST API, allowing users to transfer jobs along with their associated views and plugins, resulting in a **Context Aware Jenkins Job Transfer**.

[![GitHub release](https://img.shields.io/github/v/release/joelkariyalil/Jenkins-Transfers?logo=github&style=for-the-badge)](https://github.com/joelkariyalil/Context-Aware-Jenkins-Job-Transfers/releases)
[[![Read the Docs](https://img.shields.io/readthedocs/context-aware-jenkins-transfers-documentation?style=for-the-badge)](https://pypi.org/project/Context-Aware-Jenkins-Job-Transfers/)]
[![Contributors](https://img.shields.io/github/contributors/joelkariyalil/Jenkins-Transfers?style=for-the-badge)](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contributors.html)
[![Issues](https://img.shields.io/github/issues/joelkariyalil/Jenkins-Transfers?style=for-the-badge)](https://github.com/joelkariyalil/Context-Aware-Jenkins-Job-Transfers/issues)
[![Downloads](https://img.shields.io/badge/Downloads-6000-brightgreen?style=for-the-badge)](https://pypi.org/project/context-aware-jenkins-job-transfers/)




## Overview of Capabilities

- **Transfer Job(s)**
- **Transfer View(s)**
- **Check for Plugin Dependencies** of Jobs/Views   
- **Clean Up Jenkins Servers**
- **Visualize all functionalities** in a well-crafted terminal screen

For more details, check out the [**Supported Functionalities**](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/usage.html) section, including information on how to install the project.

## Contents

- [Installation](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/installation.html)
- [Supported Functionalities](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/usage.html)
- [Known Issues](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/knownIssues.html)
- [Change Log](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/changeLog.html)
- [Contributions](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contribution.html)
- [Apache License](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/license.html)
- [FAQs](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/FAQs.html)
- [Contributors](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contributors.html)
- [Contact the Author](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contact.html)
- [Acknowledgements](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/acknowledgement.html)

## Comparison with Other Jenkins Transfer Tools

The current available methods of moving jobs among Jenkins servers are described [here](https://medium.com/@rajinikanthvadla9/jenkins-moving-from-one-server-to-another-server-methods-39437733b1e0).

| **Feature**                | **Context Aware Jenkins Job Transfers**                                                | **Other Jenkins Transfer Tools**                           |
|----------------------------|----------------------------------------------------------------------------------------|------------------------------------------------------------|
| **Job Transfer**            | Seamless transfer of jobs between Jenkins servers with associated views and plugins.    | Basic job transfer functionality; often lacks comprehensive job context. |
| **View Transfer**           | Transfers views (all jobs in views) in a single operation.                                    | No support for transferring views |
| **Plugin Dependency Check** | Automatically checks for plugin dependencies and resolves them during the transfer.     | No support for checking plugin dependencies          |
| **Terminal Visualization**  | Full visualization of transfer steps in the terminal for better user interaction.       | Often lacks terminal-level feedback or logging.             |
| **Python Integration**      | Written in Python for easy integration with other Python projects.                      | Often script-heavy or requires additional configuration files. |
| **Workflow Scope**          | Allows workflows to be built pythonically, leveraging Python tools.                     | Often script-heavy, requiring more configuration.           |

## Issue Tracking

Kindly check out the [known Issues](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/knownIssues.html) to keep track of any bugs or enhancements. If the issue is not listed, create a new issue on the [GitHub Issues](https://github.com/joelkariyalil/Jenkins-Transfers/issues) page!

## Contributors

Check out the [List of Contributors](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contributors.html) who have helped build this project.

## Contact the Author

Feel free to reach out via [Social Media Handles](https://context-aware-jenkins-transfers-documentation.readthedocs.io/en/latest/contact.html#social-media-handles) for any questions or feedback.

## Support the Author

If you appreciate my work, consider supporting me:  
[![Buy Me a Coffee](https://img.shields.io/badge/Buy_Me_A_Coffee-F7DF1E?logo=buy-me-a-coffee&logoColor=black&style=for-the-badge)](https://buymeacoffee.com/joelkariyalil)
